#include <bits/stdc++.h>

using namespace std;

void resultPair(vector<long long int> a, long long int n) {
    int temp;
    int result = 0;
    long long int iter = n - 1;

    string pairs;

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < iter; j++) {
            if(a[j] > a[j + 1]) {
                temp = a[j];
                a[j] = a[j + 1];
                a[j + 1] = temp;

                result++;

                int a1 = j + 1;
                int a2 = j + 2;

                string a3 = to_string(a1);
                string a4 = to_string(a2);
                pairs = pairs + "\n" + a3 + " " + a4;
            }
        }
    }
    string res= to_string(result);
    pairs = res + pairs;
    cout << pairs << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long int n;
    cin >> n;

    vector<long long int> a(n);
    for(long long int i = 0; i < n; i++)
        cin >> a[i];

    resultPair(a, n);
}